# -*- encoding: utf8 -*-

from PyQt4 import QtGui, QtCore
from ui_addpolygon import Ui_addPolygonDialog
import mediator

class AddPolygon(QtGui.QDialog):
	def __init__(self):
		QtGui.QDialog.__init__(self)

		self.ui = Ui_addPolygonDialog()
		self.ui.setupUi(self)
		
	
	@QtCore.pyqtSignature("")
	def on_addPointButton_clicked(self):
		rc = self.ui.pointsTable.rowCount()
		self.ui.pointsTable.setRowCount(rc+1)

	@QtCore.pyqtSignature("")
	def on_removePointButton_clicked(self):
		row = self.ui.pointsTable.currentRow()
		self.ui.pointsTable.removeRow(row)

	def on_addButtonBox_accepted(self):
		t = self.ui.pointsTable
		coordPairs = []
		for i in range(t.rowCount()):
			coordPairs.append( ( int(t.item(i,0).text()), int(t.item(i,1).text()) ) )

		mediator.addPolygon(coordPairs, self.ui.nameEdit.text())
		self.clearWidget()

	def on_addButtonBox_rejected(self):
		self.close()
		
	def clearWidget(self):
		self.ui.pointsTable.setRowCount(0)
		self.ui.nameEdit.clear()
