# -*- coding: utf-8 -*-

from PyQt4 import QtGui, QtCore
from ui_mainwindow import Ui_mainWindow
from about import About
from addpoint import AddPoint
from addpolygon import AddPolygon
from addline import AddLine
from addcurve import AddCurve
from translatedialog import TranslateDialog
from scaledialog import ScaleDialog
from rotatedialog import RotateDialog
import mediator

class MainWindow(QtGui.QMainWindow):
	def __init__(self):
		QtGui.QMainWindow.__init__(self)

		self.ui = Ui_mainWindow()
		self.ui.setupUi(self)

	def setListModel(self, listModel):
		self.ui.objectList.setModel(listModel)

	@QtCore.pyqtSignature("")
	def on_actionPonto_activated(self):
		addPointDialog = AddPoint()
		addPointDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_actionLinha_activated(self):
		addLineDialog = AddLine()
		addLineDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_actionPoligono_activated(self):
		addPolygonDialog = AddPolygon()
		addPolygonDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_actionCurva_activated(self):
		addCurveDialog = AddCurve()
		addCurveDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_actionSobre_activated(self):
		aboutDialog = About()
		aboutDialog.exec_()
		
	@QtCore.pyqtSignature("")
	def on_removeButton_clicked(self):
		indexes = self.ui.objectList.selectedIndexes()
		names = map(lambda i: i.data().toString(), indexes)
		mediator.removeObjects(names)

	@QtCore.pyqtSignature("")
	def on_moveButton_clicked(self):
		items = self.ui.objectList.selectedIndexes()
		translateDialog = TranslateDialog(items)
		translateDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_scaleButton_clicked(self):
		items = self.ui.objectList.selectedIndexes()
		scaleDialog = ScaleDialog(items)
		scaleDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_rotateButton_clicked(self):
		items = self.ui.objectList.selectedIndexes()
		rotateDialog = RotateDialog(items)
		rotateDialog.exec_()

	@QtCore.pyqtSignature("")
	def on_colorButton_clicked(self):
		items = self.ui.objectList.selectedIndexes()
		chosenColor = QtGui.QColorDialog.getColor()
		mediator.colorizeObjects(items, chosenColor)

	@QtCore.pyqtSignature("")
	def on_upButton_pressed(self):
		amount = self.ui.navSpinner.value()
		mediator.verticalMove(amount)

	@QtCore.pyqtSignature("")
	def on_downButton_pressed(self):
		amount = self.ui.navSpinner.value()
		mediator.verticalMove(-amount)

	@QtCore.pyqtSignature("")
	def on_leftButton_pressed(self):
		amount = self.ui.navSpinner.value()
		mediator.horizontalMove(-amount)

	@QtCore.pyqtSignature("")
	def on_rightButton_pressed(self):
		amount = self.ui.navSpinner.value()
		mediator.horizontalMove(amount)

	@QtCore.pyqtSignature("")
	def on_zoomUpButton_clicked(self):
		mediator.zoom(0.8)

	@QtCore.pyqtSignature("")
	def on_zoomDownButton_clicked(self):
		mediator.zoom(1.2)

	@QtCore.pyqtSignature("")
	def on_rotateWindowButton_clicked(self):
		angle = int(self.ui.rotateEdit.text())
		mediator.rotateWindow(angle)
