#!/usr/bin/env python

# -*- coding: utf-8 -*-
# By Jeff Winkler, http://jeffwinkler.net
# GUI by Renato Besen

import glob,os,stat,time,sys
from subprocess import *
from PyQt4.QtGui import *
from PyQt4.QtCore import *

'''
Watch for changes in all .py files. If changes, run nosetests. 
'''
def checkSum(dir = "."):
    ''' Return a long which can be used to know if any .py files have changed.
    Only looks in the current directory. '''
    val = 0
    for root, dirs, files in os.walk(dir):
        for f in files:
            if f.endswith(".py"):
                name = dir + "/" + f
                try:
                    stats = os.stat (name)
                except: pass
                val += stats [stat.ST_SIZE] + stats [stat.ST_MTIME]
        for d in dirs:
            val += checkSum(d)
    return val


class Nosy(QThread):
    def run(self):
        val = 0
        while (True):
            if checkSum() != val:
                val=checkSum()

                # executa testes
                p = Popen('nosetests -d', shell=True,stdin=PIPE, stdout=PIPE, stderr=PIPE, close_fds=True)
                saida_erro = p.stderr.readlines()
                print "".join(saida_erro)

                mensagem = saida_erro[-1]
                cor = "red"
                if mensagem.strip() == "OK":
                    cor = "green"
                mensagem = "<font color=%s size=50>%s</font>" % (cor,mensagem)
                self.emit(SIGNAL("executouTestes(QString)"), mensagem)
            self.sleep(3)

class Label(QLabel):
    def __init__(self, parent=None):
        super(QLabel,self).__init__(parent)
        self.setMargin(10)
        self.resize(200,70)
        self.nosy = Nosy()
        self.connect(self.nosy, SIGNAL("executouTestes(QString)"), self.setText)
        self.nosy.start()
        
if __name__ == "__main__":
    app = QApplication(sys.argv)
    label = Label()
    label.show()
    sys.exit(app.exec_())
