# -*- coding: utf8 -*-

import sys

def clipLine(p0, p1, wmin, wmax):
	t0, t1 = 0.0, 1.0
	dx, dy = float(p1[0] - p0[0]), float(p1[1] - p0[1])
	
	ps = [-dx, dx, -dy, dy]
	qs = [p0[0] - wmin[0],  wmax[0] - p0[0],  p0[1] - wmin[1],  wmax[1] - p0[1]]
	
	#for each edge (left, right, bottom, top)
	for (p,q) in zip(ps,qs):
		if(p == 0):
			if(q < 0):
				return None
			# what else if p == 0 and q >= 0?
		elif(p < 0):
			r = q/p
			if(r > t1):
				return None
			elif(r > t0):
				t0 = r
		else: # p > 0
			r = q/p
			if(r < t0):
				return None
			elif(r < t1):
				t1 = r
	
	# the line wasn't rejected, so lets calculate its new points
	p0_ = (p0[0] + t0*dx, p0[1] + t0*dy)
	p1_ = (p0[0] + t1*dx, p0[1] + t1*dy)
	
	return (p0_, p1_)
